Index: uspace/srv/net/tl/icmp/icmp.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp.c	(revision 22027b6e7981eafebc4220c771cc114cfcc00c1f)
+++ uspace/srv/net/tl/icmp/icmp.c	(revision 8b5690f2670aee6dddfa3127ce14232d1d21555d)
@@ -416,566 +663,147 @@
 	size_t count = sizeof(names) / sizeof(measured_string_t);
 	uint8_t *data;
-	int rc;
-
-	fibril_rwlock_initialize(&icmp_globals.lock);
-	fibril_rwlock_write_lock(&icmp_globals.lock);
-	icmp_replies_initialize(&icmp_globals.replies);
-	icmp_echo_data_initialize(&icmp_globals.echo_data);
-	
-	icmp_globals.ip_phone = ip_bind_service(SERVICE_IP, IPPROTO_ICMP,
-	    SERVICE_ICMP, client_connection);
-	if (icmp_globals.ip_phone < 0) {
-		fibril_rwlock_write_unlock(&icmp_globals.lock);
-		return icmp_globals.ip_phone;
-	}
-	
-	rc = ip_packet_size_req(icmp_globals.ip_phone, -1,
-	    &icmp_globals.packet_dimension);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&icmp_globals.lock);
+	
+	if (!hash_table_create(&replies, REPLY_BUCKETS, REPLY_KEYS, &reply_ops))
+		return ENOMEM;
+	
+	fibril_mutex_initialize(&reply_lock);
+	atomic_set(&icmp_client, 0);
+	
+	phone_net = net_phone;
+	phone_ip = ip_bind_service(SERVICE_IP, IPPROTO_ICMP, SERVICE_ICMP,
+	    icmp_receiver);
+	if (phone_ip < 0)
+		return phone_ip;
+	
+	int rc = ip_packet_size_req(phone_ip, -1, &icmp_dimension);
+	if (rc != EOK)
 		return rc;
-	}
-
-	icmp_globals.packet_dimension.prefix += ICMP_HEADER_SIZE;
-	icmp_globals.packet_dimension.content -= ICMP_HEADER_SIZE;
-
-	icmp_globals.error_reporting = NET_DEFAULT_ICMP_ERROR_REPORTING;
-	icmp_globals.echo_replying = NET_DEFAULT_ICMP_ECHO_REPLYING;
-
+	
+	icmp_dimension.prefix += ICMP_HEADER_SIZE;
+	icmp_dimension.content -= ICMP_HEADER_SIZE;
+	
 	/* Get configuration */
 	configuration = &names[0];
-	rc = net_get_conf_req(icmp_globals.net_phone, &configuration, count,
-	    &data);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&icmp_globals.lock);
+	rc = net_get_conf_req(phone_net, &configuration, count, &data);
+	if (rc != EOK)
 		return rc;
-	}
 	
 	if (configuration) {
-		if (configuration[0].value) {
-			icmp_globals.error_reporting =
-			    (configuration[0].value[0] == 'y');
-		}
-		if (configuration[1].value) {
-			icmp_globals.echo_replying =
-			    (configuration[1].value[0] == 'y');
-		}
+		if (configuration[0].value)
+			error_reporting = (configuration[0].value[0] == 'y');
+		
+		if (configuration[1].value)
+			echo_replying = (configuration[1].value[0] == 'y');
+		
 		net_free_settings(configuration, data);
 	}
-
-	fibril_rwlock_write_unlock(&icmp_globals.lock);
+	
 	return EOK;
 }
 
-/** Tries to set the pending reply result as the received message type.
- *
- * If the reply data is not present, the reply timed out and the other fibril
- * is already awake.
- * Releases the packet.
- *
- * @param[in] packet	The received reply message.
- * @param[in] header	The ICMP message header.
- * @param[in] type	The received reply message type.
- * @param[in] code	The received reply message code.
- */
-static void  icmp_process_echo_reply(packet_t *packet, icmp_header_t *header,
-    icmp_type_t type, icmp_code_t code)
-{
-	int reply_key;
-	icmp_reply_t *reply;
-
-	/* Compute the reply key */
-	reply_key = ICMP_GET_REPLY_KEY(header->un.echo.identifier,
-	    header->un.echo.sequence_number);
-	pq_release_remote(icmp_globals.net_phone, packet_get_id(packet));
-
-	/* Find the pending reply */
-	fibril_rwlock_write_lock(&icmp_globals.lock);
-	reply = icmp_replies_find(&icmp_globals.replies, reply_key);
-	if (reply) {
-		reply->result = type;
-		fibril_condvar_signal(&reply->condvar);
-	}
-	fibril_rwlock_write_unlock(&icmp_globals.lock);
-}
-
-/** Processes the received ICMP packet.
- *
- * Notifies the destination socket application.
- *
- * @param[in,out] packet The received packet.
- * @param[in] error	The packet error reporting service. Prefixes the
- *			received packet.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		EINVAL if the stored packet address is not the an_addr_t.
- * @return		EINVAL if the packet does not contain any data.
- * @return		NO_DATA if the packet content is shorter than the user
- *			datagram header.
- * @return		ENOMEM if there is not enough memory left.
- * @return		EADDRNOTAVAIL if the destination socket does not exist.
- * @return		Other error codes as defined for the
- *			ip_client_process_packet() function.
- */
-static int icmp_process_packet(packet_t *packet, services_t error)
-{
-	size_t length;
-	uint8_t *src;
-	int addrlen;
-	int result;
-	void *data;
-	icmp_header_t *header;
-	icmp_type_t type;
-	icmp_code_t code;
+/** Per-connection initialization
+ *
+ * Initialize client-specific global variables.
+ *
+ */
+void tl_connection(void)
+{
+	icmp_id = (icmp_param_t) atomic_postinc(&icmp_client);
+	icmp_seq = 1;
+}
+
+/** Process the ICMP message.
+ *
+ * @param[in]  callid Message identifier.
+ * @param[in]  call   Message parameters.
+ * @param[out] answer Answer.
+ * @param[out] count  Number of arguments of the answer.
+ *
+ * @return EOK on success.
+ * @return ENOTSUP if the message is not known.
+ * @return Other error codes as defined for the packet_translate()
+ *         function.
+ * @return Other error codes as defined for the
+ *         icmp_destination_unreachable() function.
+ * @return Other error codes as defined for the
+ *         icmp_source_quench() function.
+ * @return Other error codes as defined for the
+ *         icmp_time_exceeded() function.
+ * @return Other error codes as defined for the
+ *         icmp_parameter_problem() function.
+ *
+ * @see icmp_remote.h
+ * @see IS_NET_ICMP_MESSAGE()
+ *
+ */
+int tl_message(ipc_callid_t callid, ipc_call_t *call,
+    ipc_call_t *answer, size_t *count)
+{
+	struct sockaddr *addr;
+	size_t size;
+	packet_t *packet;
 	int rc;
 	
-	switch (error) {
-	case SERVICE_NONE:
-		break;
-	case SERVICE_ICMP:
-		/* Process error */
-		result = icmp_client_process_packet(packet, &type, &code, NULL,
-		    NULL);
-		if (result < 0)
-			return result;
-		length = (size_t) result;
-		/* Remove the error header */
-		rc = packet_trim(packet, length, 0);
+	*count = 0;
+	
+	switch (IPC_GET_IMETHOD(*call)) {
+	case NET_ICMP_ECHO:
+		rc = async_data_write_accept((void **) &addr, false, 0, 0, 0, &size);
 		if (rc != EOK)
 			return rc;
-		break;
-	default:
-		return ENOTSUP;
-	}
-
-	/* Get rid of the IP header */
-	length = ip_client_header_length(packet);
-	rc = packet_trim(packet, length, 0);
-	if (rc != EOK)
+		
+		rc = icmp_echo(icmp_id, icmp_seq, ICMP_GET_SIZE(*call),	
+		    ICMP_GET_TIMEOUT(*call), ICMP_GET_TTL(*call),
+		    ICMP_GET_TOS(*call), ICMP_GET_DONT_FRAGMENT(*call),
+		    addr, (socklen_t) size);
+		
+		free(addr);
+		icmp_seq++;
 		return rc;
-
-	length = packet_get_data_length(packet);
-	if (length <= 0)
-		return EINVAL;
-
-	if (length < ICMP_HEADER_SIZE)
-		return EINVAL;
-
-	data = packet_get_data(packet);
-	if (!data)
-		return EINVAL;
-
-	/* Get ICMP header */
-	header = (icmp_header_t *) data;
-
-	if (header->checksum) {
-		while (ICMP_CHECKSUM(header, length) != IP_CHECKSUM_ZERO) {
-			/*
-			 * Set the original message type on error notification.
-			 * Type swap observed in Qemu.
-			 */
-			if (error) {
-				switch (header->type) {
-				case ICMP_ECHOREPLY:
-					header->type = ICMP_ECHO;
-					continue;
-				}
-			}
-			return EINVAL;
-		}
-	}
-
-	switch (header->type) {
-	case ICMP_ECHOREPLY:
-		if (error)
-			icmp_process_echo_reply(packet, header, type, code);
-		else
-			icmp_process_echo_reply(packet, header, ICMP_ECHO, 0);
-
-		return EOK;
-
-	case ICMP_ECHO:
-		if (error) {
-			icmp_process_echo_reply(packet, header, type, code);
-			return EOK;
-		}
-		
-		/* Do not send a reply if disabled */
-		if (icmp_globals.echo_replying) {
-			addrlen = packet_get_addr(packet, &src, NULL);
-
-			/*
-			 * Set both addresses to the source one (avoids the
-			 * source address deletion before setting the
-			 * destination one).
-			 */
-			if ((addrlen > 0) && (packet_set_addr(packet, src, src,
-			    (size_t) addrlen) == EOK)) {
-				/* Send the reply */
-				icmp_send_packet(ICMP_ECHOREPLY, 0, packet,
-				    header, 0, 0, 0, 0);
-				return EOK;
-			}
-
-			return EINVAL;
-		}
-
-		return EPERM;
-
-	case ICMP_DEST_UNREACH:
-	case ICMP_SOURCE_QUENCH:
-	case ICMP_REDIRECT:
-	case ICMP_ALTERNATE_ADDR:
-	case ICMP_ROUTER_ADV:
-	case ICMP_ROUTER_SOL:
-	case ICMP_TIME_EXCEEDED:
-	case ICMP_PARAMETERPROB:
-	case ICMP_CONVERSION_ERROR:
-	case ICMP_REDIRECT_MOBILE:
-	case ICMP_SKIP:
-	case ICMP_PHOTURIS:
-		ip_received_error_msg(icmp_globals.ip_phone, -1, packet,
-		    SERVICE_IP, SERVICE_ICMP);
-		return EOK;
-
-	default:
-		return ENOTSUP;
-	}
-}
-
-/** Processes the received ICMP packet.
- *
- * Is used as an entry point from the underlying IP module.
- * Releases the packet on error.
- *
- * @param device_id	The device identifier. Ignored parameter.
- * @param[in,out] packet The received packet.
- * @param receiver	The target service. Ignored parameter.
- * @param[in] error	The packet error reporting service. Prefixes the
- *			received packet.
- * @return		EOK on success.
- * @return		Other error codes as defined for the
- *			icmp_process_packet() function.
- */
-static int icmp_received_msg_local(device_id_t device_id, packet_t *packet,
-    services_t receiver, services_t error)
-{
-	int rc;
-
-	rc = icmp_process_packet(packet, error);
-	if (rc != EOK)
-		return icmp_release_and_return(packet, rc);
-
-	return EOK;
-}
-
-/** Processes the generic client messages.
- *
- * @param[in] call	The message parameters.
- * @return		EOK on success.
- * @return		ENOTSUP if the message is not known.
- * @return		Other error codes as defined for the packet_translate()
- *			function.
- * @return		Other error codes as defined for the
- *			icmp_destination_unreachable_msg_local() function.
- * @return		Other error codes as defined for the
- *			icmp_source_quench_msg_local() function.
- * @return		Other error codes as defined for the
- *			icmp_time_exceeded_msg_local() function.
- * @return		Other error codes as defined for the
- *			icmp_parameter_problem_msg_local() function.
- *
- * @see icmp_interface.h
- */
-static int icmp_process_message(ipc_call_t *call)
-{
-	packet_t *packet;
-	int rc;
-
-	switch (IPC_GET_IMETHOD(*call)) {
+	
 	case NET_ICMP_DEST_UNREACH:
-		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
-		    IPC_GET_PACKET(call));
+		rc = packet_translate_remote(phone_net, &packet,
+		    IPC_GET_PACKET(*call));
 		if (rc != EOK)
 			return rc;
-		return icmp_destination_unreachable_msg_local(0,
-		    ICMP_GET_CODE(call), ICMP_GET_MTU(call), packet);
+		
+		return icmp_destination_unreachable(ICMP_GET_CODE(*call),
+		    ICMP_GET_MTU(*call), packet);
+	
 	case NET_ICMP_SOURCE_QUENCH:
-		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
-		    IPC_GET_PACKET(call));
+		rc = packet_translate_remote(phone_net, &packet,
+		    IPC_GET_PACKET(*call));
 		if (rc != EOK)
 			return rc;
-		return icmp_source_quench_msg_local(0, packet);
+		
+		return icmp_source_quench(packet);
+	
 	case NET_ICMP_TIME_EXCEEDED:
-		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
-		    IPC_GET_PACKET(call));
+		rc = packet_translate_remote(phone_net, &packet,
+		    IPC_GET_PACKET(*call));
 		if (rc != EOK)
 			return rc;
-		return icmp_time_exceeded_msg_local(0, ICMP_GET_CODE(call),
-		    packet);
+		
+		return icmp_time_exceeded(ICMP_GET_CODE(*call), packet);
+	
 	case NET_ICMP_PARAMETERPROB:
-		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
-		    IPC_GET_PACKET(call));
+		rc = packet_translate_remote(phone_net, &packet,
+		    IPC_GET_PACKET(*call));
 		if (rc != EOK)
 			return rc;
-		return icmp_parameter_problem_msg_local(0, ICMP_GET_CODE(call),
-		    ICMP_GET_POINTER(call), packet);
-	default:
-		return ENOTSUP;
-	}
-}
-
-/** Assigns a new identifier for the connection.
- *
- * Fills the echo data parameter with the assigned values.
- *
- * @param[in,out] echo_data The echo data to be bound.
- * @return		Index of the inserted echo data.
- * @return		EBADMEM if the echo_data parameter is NULL.
- * @return		ENOTCONN if no free identifier have been found.
- */
-static int icmp_bind_free_id(icmp_echo_t *echo_data)
-{
-	icmp_param_t index;
-
-	if (!echo_data)
-		return EBADMEM;
-
-	/* From the last used one */
-	index = icmp_globals.last_used_id;
-	do {
-		index++;
-		/* til the range end */
-		if (index >= ICMP_FREE_IDS_END) {
-			/* start from the range beginning */
-			index = ICMP_FREE_IDS_START - 1;
-			do {
-				index++;
-				/* til the last used one */
-				if (index >= icmp_globals.last_used_id) {
-					/* none found */
-					return ENOTCONN;
-				}
-			} while(icmp_echo_data_find(&icmp_globals.echo_data,
-			    index) != NULL);
-
-			/* Found, break immediately */
-			break;
-		}
-	} while (icmp_echo_data_find(&icmp_globals.echo_data, index) != NULL);
-
-	echo_data->identifier = index;
-	echo_data->sequence_number = 0;
-
-	return icmp_echo_data_add(&icmp_globals.echo_data, index, echo_data);
-}
-
-/** Processes the client messages.
- *
- * Remembers the assigned identifier and sequence numbers.
- * Runs until the client module disconnects.
- *
- * @param[in] callid	The message identifier.
- * @param[in] call	The message parameters.
- * @return EOK.
- *
- * @see icmp_interface.h
- * @see icmp_api.h
- */
-static int icmp_process_client_messages(ipc_callid_t callid, ipc_call_t call)
-{
-	bool keep_on_going = true;
-	ipc_call_t answer;
-	int answer_count;
-	size_t length;
-	struct sockaddr *addr;
-	ipc_callid_t data_callid;
-	icmp_echo_t *echo_data;
-	int rc = EOK;
-
-	/*
-	 * Accept the connection
-	 *  - Answer the first NET_ICMP_INIT call.
-	 */
-	answer_count = 0;
-
-	echo_data = (icmp_echo_t *) malloc(sizeof(*echo_data));
-	if (!echo_data)
-		return ENOMEM;
-
-	/* Assign a new identifier */
-	fibril_rwlock_write_lock(&icmp_globals.lock);
-	rc = icmp_bind_free_id(echo_data);
-	fibril_rwlock_write_unlock(&icmp_globals.lock);
-	if (rc < 0) {
-		free(echo_data);
-		return rc;
-	}
-
-	while (keep_on_going) {
-		/* Answer the call */
-		answer_call(callid, rc, &answer, answer_count);
-
-		/* Refresh data */
-		refresh_answer(&answer, &answer_count);
-
-		/* Get the next call */
-		callid = async_get_call(&call);
-
-		/* Process the call */
-		switch (IPC_GET_IMETHOD(call)) {
-		case IPC_M_PHONE_HUNGUP:
-			keep_on_going = false;
-			rc = EHANGUP;
-			break;
-		
-		case NET_ICMP_ECHO:
-			if (!async_data_write_receive(&data_callid, &length)) {
-				rc = EINVAL;
-				break;
-			}
-			
-			addr = malloc(length);
-			if (!addr) {
-				rc = ENOMEM;
-				break;
-			}
-			
-			rc = async_data_write_finalize(data_callid, addr,
-			    length);
-			if (rc != EOK) {
-				free(addr);
-				break;
-			}
-
-			fibril_rwlock_write_lock(&icmp_globals.lock);
-			rc = icmp_echo(echo_data->identifier,
-			    echo_data->sequence_number, ICMP_GET_SIZE(call),
-			    ICMP_GET_TIMEOUT(call), ICMP_GET_TTL(call),
-			    ICMP_GET_TOS(call), ICMP_GET_DONT_FRAGMENT(call),
-			    addr, (socklen_t) length);
-			fibril_rwlock_write_unlock(&icmp_globals.lock);
-
-			free(addr);
-
-			if (echo_data->sequence_number < UINT16_MAX)
-				echo_data->sequence_number++;
-			else
-				echo_data->sequence_number = 0;
-
-			break;
-
-		default:
-			rc = icmp_process_message(&call);
-		}
-
-	}
-
-	/* Release the identifier */
-	fibril_rwlock_write_lock(&icmp_globals.lock);
-	icmp_echo_data_exclude(&icmp_globals.echo_data, echo_data->identifier);
-	fibril_rwlock_write_unlock(&icmp_globals.lock);
-
-	return rc;
-}
-
-/** Processes the ICMP message.
- *
- * @param[in] callid	The message identifier.
- * @param[in] call	The message parameters.
- * @param[out] answer	The message answer parameters.
- * @param[out] answer_count The last parameter for the actual answer in the
- *			answer parameter.
- * @return		EOK on success.
- * @return		ENOTSUP if the message is not known.
- *
- * @see icmp_interface.h
- * @see IS_NET_ICMP_MESSAGE()
- */
-int icmp_message_standalone(ipc_callid_t callid, ipc_call_t *call,
-    ipc_call_t *answer, int *answer_count)
-{
-	packet_t *packet;
-	int rc;
-
-	*answer_count = 0;
-	switch (IPC_GET_IMETHOD(*call)) {
-	case NET_TL_RECEIVED:
-		rc = packet_translate_remote(icmp_globals.net_phone, &packet,
-		    IPC_GET_PACKET(call));
-		if (rc != EOK)
-			return rc;
-		return icmp_received_msg_local(IPC_GET_DEVICE(call), packet,
-		    SERVICE_ICMP, IPC_GET_ERROR(call));
-	
-	case NET_ICMP_INIT:
-		return icmp_process_client_messages(callid, * call);
-	
-	default:
-		return icmp_process_message(call);
-	}
-
+		
+		return icmp_parameter_problem(ICMP_GET_CODE(*call),
+		    ICMP_GET_POINTER(*call), packet);
+	}
+	
 	return ENOTSUP;
 }
 
-
-/** Default thread for new connections.
- *
- * @param[in] iid The initial message identifier.
- * @param[in] icall The initial message call structure.
- *
- */
-static void tl_client_connection(ipc_callid_t iid, ipc_call_t *icall)
-{
-	/*
-	 * Accept the connection
-	 *  - Answer the first IPC_M_CONNECT_ME_TO call.
-	 */
-	ipc_answer_0(iid, EOK);
-	
-	while (true) {
-		ipc_call_t answer;
-		int answer_count;
-		
-		/* Clear the answer structure */
-		refresh_answer(&answer, &answer_count);
-		
-		/* Fetch the next message */
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-		
-		/* Process the message */
-		int res = tl_module_message_standalone(callid, &call, &answer,
-		    &answer_count);
-		
-		/*
-		 * End if told to either by the message or the processing
-		 * result.
-		 */
-		if ((IPC_GET_IMETHOD(call) == IPC_M_PHONE_HUNGUP) ||
-		    (res == EHANGUP))
-			return;
-		
-		/* Answer the message */
-		answer_call(callid, res, &answer, answer_count);
-	}
-}
-
-/** Starts the module.
- *
- * @return		EOK on success.
- * @return		Other error codes as defined for each specific module
- *			start function.
- */
 int main(int argc, char *argv[])
 {
-	int rc;
-	
 	/* Start the module */
-	rc = tl_module_start_standalone(tl_client_connection);
-	return rc;
+	return tl_module_start(SERVICE_ICMP);
 }
 
 /** @}
  */
-
Index: uspace/srv/net/tl/tcp/Makefile
===================================================================
--- uspace/srv/net/tl/tcp/Makefile	(revision 22027b6e7981eafebc4220c771cc114cfcc00c1f)
+++ uspace/srv/net/tl/tcp/Makefile	(revision 8b5690f2670aee6dddfa3127ce14232d1d21555d)
@@ -34,6 +34,5 @@
 
 SOURCES = \
-	tcp.c \
-	tcp_module.c
+	tcp.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/net/tl/tcp/tcp.c
===================================================================
--- uspace/srv/net/tl/tcp/tcp.c	(revision 22027b6e7981eafebc4220c771cc114cfcc00c1f)
+++ uspace/srv/net/tl/tcp/tcp.c	(revision 8b5690f2670aee6dddfa3127ce14232d1d21555d)
@@ -36,8 +36,4 @@
  */
 
-#include "tcp.h"
-#include "tcp_header.h"
-#include "tcp_module.h"
-
 #include <assert.h>
 #include <async.h>
@@ -48,5 +44,4 @@
 #include <errno.h>
 
-#include <ipc/ipc.h>
 #include <ipc/services.h>
 #include <ipc/net.h>
@@ -68,13 +63,16 @@
 #include <ip_interface.h>
 #include <icmp_client.h>
-#include <icmp_interface.h>
+#include <icmp_remote.h>
 #include <net_interface.h>
 #include <socket_core.h>
 #include <tl_common.h>
-#include <tl_local.h>
-#include <tl_interface.h>
+#include <tl_remote.h>
+#include <tl_skel.h>
+
+#include "tcp.h"
+#include "tcp_header.h"
 
 /** TCP module name. */
-#define NAME	"TCP protocol"
+#define NAME  "tcp"
 
 /** The TCP window default value. */
@@ -220,46 +218,4 @@
 /** TCP global data. */
 tcp_globals_t tcp_globals;
-
-/** Initializes the TCP module.
- *
- * @param[in] client_connection The client connection processing function. The
- *			module skeleton propagates its own one.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
- */
-int tcp_initialize(async_client_conn_t client_connection)
-{
-	int rc;
-
-	assert(client_connection);
-
-	fibril_rwlock_initialize(&tcp_globals.lock);
-	fibril_rwlock_write_lock(&tcp_globals.lock);
-
-	tcp_globals.icmp_phone = icmp_connect_module(SERVICE_ICMP,
-	    ICMP_CONNECT_TIMEOUT);
-	tcp_globals.ip_phone = ip_bind_service(SERVICE_IP, IPPROTO_TCP,
-	    SERVICE_TCP, client_connection);
-	if (tcp_globals.ip_phone < 0) {
-		fibril_rwlock_write_unlock(&tcp_globals.lock);
-		return tcp_globals.ip_phone;
-	}
-	
-	rc = socket_ports_initialize(&tcp_globals.sockets);
-	if (rc != EOK)
-		goto out;
-
-	rc = packet_dimensions_initialize(&tcp_globals.dimensions);
-	if (rc != EOK) {
-		socket_ports_destroy(&tcp_globals.sockets);
-		goto out;
-	}
-
-	tcp_globals.last_used_port = TCP_FREE_PORTS_START - 1;
-
-out:
-	fibril_rwlock_write_unlock(&tcp_globals.lock);
-	return rc;
-}
 
 int tcp_received_msg(device_id_t device_id, packet_t *packet,
@@ -1247,4 +1203,11 @@
 }
 
+/** Per-connection initialization
+ *
+ */
+void tl_connection(void)
+{
+}
+
 /** Processes the TCP message.
  *
@@ -1260,11 +1223,7 @@
  * @see IS_NET_TCP_MESSAGE()
  */
-int
-tcp_message_standalone(ipc_callid_t callid, ipc_call_t *call,
-    ipc_call_t *answer, int *answer_count)
-{
-	packet_t *packet;
-	int rc;
-
+int tl_message(ipc_callid_t callid, ipc_call_t *call,
+    ipc_call_t *answer, size_t *answer_count)
+{
 	assert(call);
 	assert(answer);
@@ -1273,16 +1232,4 @@
 	*answer_count = 0;
 	switch (IPC_GET_IMETHOD(*call)) {
-	case NET_TL_RECEIVED:
-//		fibril_rwlock_read_lock(&tcp_globals.lock);
-		rc = packet_translate_remote(tcp_globals.net_phone, &packet,
-		    IPC_GET_PACKET(call));
-		if (rc != EOK) {
-//			fibril_rwlock_read_unlock(&tcp_globals.lock);
-			return rc;
-		}
-		rc = tcp_received_msg(IPC_GET_DEVICE(call), packet, SERVICE_TCP,
-		    IPC_GET_ERROR(call));
-//		fibril_rwlock_read_unlock(&tcp_globals.lock);
-		return rc;
 	case IPC_M_CONNECT_TO_ME:
 		return tcp_process_client_messages(callid, *call);
@@ -1323,5 +1270,5 @@
 	bool keep_on_going = true;
 	socket_cores_t local_sockets;
-	int app_phone = IPC_GET_PHONE(&call);
+	int app_phone = IPC_GET_PHONE(call);
 	struct sockaddr *addr;
 	int socket_id;
@@ -1330,5 +1277,5 @@
 	fibril_rwlock_t lock;
 	ipc_call_t answer;
-	int answer_count;
+	size_t answer_count;
 	tcp_socket_data_t *socket_data;
 	socket_core_t *socket;
@@ -1558,5 +1505,5 @@
 
 	/* Release the application phone */
-	ipc_hangup(app_phone);
+	async_hangup(app_phone);
 
 	printf("release\n");
@@ -2486,61 +2433,77 @@
 }
 
-/** Default thread for new connections.
+/** Process IPC messages from the IP module
  *
- * @param[in] iid	The initial message identifier.
- * @param[in] icall	The initial message call structure.
+ * @param[in]     iid   Message identifier.
+ * @param[in,out] icall Message parameters.
  *
  */
-static void tl_client_connection(ipc_callid_t iid, ipc_call_t * icall)
-{
-	/*
-	 * Accept the connection
-	 *  - Answer the first IPC_M_CONNECT_ME_TO call.
-	 */
-	ipc_answer_0(iid, EOK);
-
+static void tcp_receiver(ipc_callid_t iid, ipc_call_t *icall)
+{
+	packet_t *packet;
+	int rc;
+	
 	while (true) {
-		ipc_call_t answer;
-		int answer_count;
-
-		/* Clear the answer structure */
-		refresh_answer(&answer, &answer_count);
-
-		/* Fetch the next message */
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-
-		/* Process the message */
-		int res = tl_module_message_standalone(callid, &call, &answer,
-		    &answer_count);
-
-		/*
-		 * End if told to either by the message or the processing
-		 * result.
-		 */
-		if ((IPC_GET_IMETHOD(call) == IPC_M_PHONE_HUNGUP) ||
-		    (res == EHANGUP))
-			return;
-
-		/*
-		 * Answer the message 
-		 */
-		answer_call(callid, res, &answer, answer_count);
-	}
-}
-
-/** Starts the module.
+		switch (IPC_GET_IMETHOD(*icall)) {
+		case NET_TL_RECEIVED:
+			rc = packet_translate_remote(tcp_globals.net_phone, &packet,
+			    IPC_GET_PACKET(*icall));
+			if (rc == EOK)
+				rc = tcp_received_msg(IPC_GET_DEVICE(*icall), packet,
+				    SERVICE_TCP, IPC_GET_ERROR(*icall));
+			
+			async_answer_0(iid, (sysarg_t) rc);
+			break;
+		default:
+			async_answer_0(iid, (sysarg_t) ENOTSUP);
+		}
+		
+		iid = async_get_call(icall);
+	}
+}
+
+/** Initialize the TCP module.
  *
- * @return		EOK on success.
- * @return		Other error codes as defined for each specific module
- *			start function.
+ * @param[in] net_phone Network module phone.
+ *
+ * @return EOK on success.
+ * @return ENOMEM if there is not enough memory left.
+ *
  */
-int
-main(int argc, char *argv[])
-{
-	int rc;
-
-	rc = tl_module_start_standalone(tl_client_connection);
+int tl_initialize(int net_phone)
+{
+	fibril_rwlock_initialize(&tcp_globals.lock);
+	fibril_rwlock_write_lock(&tcp_globals.lock);
+	
+	tcp_globals.net_phone = net_phone;
+	
+	tcp_globals.icmp_phone = icmp_connect_module(ICMP_CONNECT_TIMEOUT);
+	tcp_globals.ip_phone = ip_bind_service(SERVICE_IP, IPPROTO_TCP,
+	    SERVICE_TCP, tcp_receiver);
+	if (tcp_globals.ip_phone < 0) {
+		fibril_rwlock_write_unlock(&tcp_globals.lock);
+		return tcp_globals.ip_phone;
+	}
+	
+	int rc = socket_ports_initialize(&tcp_globals.sockets);
+	if (rc != EOK)
+		goto out;
+
+	rc = packet_dimensions_initialize(&tcp_globals.dimensions);
+	if (rc != EOK) {
+		socket_ports_destroy(&tcp_globals.sockets);
+		goto out;
+	}
+
+	tcp_globals.last_used_port = TCP_FREE_PORTS_START - 1;
+
+out:
+	fibril_rwlock_write_unlock(&tcp_globals.lock);
 	return rc;
+}
+
+int main(int argc, char *argv[])
+{
+	return tl_module_start(SERVICE_TCP);
 }
 
Index: uspace/srv/net/tl/udp/Makefile
===================================================================
--- uspace/srv/net/tl/udp/Makefile	(revision 22027b6e7981eafebc4220c771cc114cfcc00c1f)
+++ uspace/srv/net/tl/udp/Makefile	(revision 8b5690f2670aee6dddfa3127ce14232d1d21555d)
@@ -34,6 +34,5 @@
 
 SOURCES = \
-	udp.c \
-	udp_module.c
+	udp.c
 
 include $(USPACE_PREFIX)/Makefile.common
